﻿using System.Collections;
using System.Collections.Generic;
using System.Security.Permissions;
using System.Web;
using System.Web.Hosting;

namespace Samples.Bleroy {
    public class MyVirtualDirectory : VirtualDirectory {
        MyVpp _vpp;

        public MyVirtualDirectory(string virtualDir, MyVpp provider)
            : base(virtualDir) {
            _vpp = provider;
        }

        public bool Exists {
            get { return true; }
        }

        public override IEnumerable Children {
            get {
                var children = new List<VirtualFileBase>();
                foreach (var file in _vpp.Files.Keys) {
                    children.Add(
                        new MyVirtualFile(
                            VirtualPathUtility.Combine(VirtualPath, file), _vpp));
                }
                return children;
            }
        }

        public override IEnumerable Directories {
            get { return new List<MyVirtualFile>(); }
        }

        public override IEnumerable Files {
            get { return Children; }
        }
    }
}