﻿using System;
using System.Security.Permissions;
using System.Web;
using System.Web.Caching;
using System.Web.Hosting;
using System.IO;

namespace Samples.Bleroy {
    public class MyVirtualFile : VirtualFile {
            private MyVpp _vpp;

            public MyVirtualFile(string virtualPath, MyVpp provider)
                : base(virtualPath) {
                this._vpp = provider;
            }

            public bool Exists {
                get {
                    return _vpp.FileExists(Name);
                }
            }

            public override Stream Open() {
                MemoryStream stream = new MemoryStream();
                using (var writer = new StreamWriter(stream)) {
                    if (Name.StartsWith("calc-", StringComparison.InvariantCultureIgnoreCase)) {
                        var operation = HttpUtility.UrlDecode(
                            Name.Substring(5, Name.Length - 8));
                        writer.Write(@"
using System;

namespace Dynamic {
    public static class Calculator {
        public static double Operation(double A, double B) {
            return " + operation + @";
        }
    }
}");
                    }
                    else {
                        writer.Write(_vpp.Files[Name]);
                    }
                }

                return new MemoryStream(stream.GetBuffer());
            }
        }
}