﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Web.Compilation" %>
<%@ Import Namespace="System.Reflection" %>
<!DOCTYPE html>
<script runat="server">
    public void OnComputeClick(object sender, EventArgs args) {
        // Oh boy! Don't do this at home!
        var assembly = BuildManager.GetCompiledAssembly("~/vpp/calc-" + 
            HttpUtility.UrlEncode(Operation.Text) +
            ".cs");
        var dynamicType = assembly.GetTypes()[0];
        var operation = dynamicType.GetMethod("Operation", BindingFlags.Static | BindingFlags.Public);
        double a = double.Parse(A.Text);
        double b = double.Parse(B.Text);
        double result = (double)operation.Invoke(null, new object[] { a, b });
        Result.Text = result.ToString();
    }
</script>
<html>
<head runat="server">
    <title>Dynamically compiled calculation without build providers or CodeDom</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:Label runat="server" ID="OperationLabel" 
            AssociatedControlID="Operation" Text="Operation:" />
        <asp:TextBox runat="server" ID="Operation" Text="A + B" />
        <br />
        <asp:Label runat="server" ID="ALabel" 
            AssociatedControlID="Operation" Text="A:" />
        <asp:TextBox runat="server" ID="A" Text="2" />
        <br />
        <asp:Label runat="server" ID="BLabel" 
            AssociatedControlID="Operation" Text="B:" />
        <asp:TextBox runat="server" ID="B" Text="40" />
        <br />
        <asp:button runat="server" ID="Compute" Text="Compute" OnClick="OnComputeClick" />
        <asp:Label runat="server" ID="Result" />
    </div>
    </form>
</body>
</html>
